# Copyright (c) 2004 Marek Hnilica. All rights reserved.
# Module providing gui for freedb search
# Distributed under GPL version 2, or (at your option) later

from wxPython.wx import *
import PyCDDB,string,types
def TranslateToStr(List):
	TempList=[]
	for element in List:
		TempList.append(str(element))
	return TempList
def Message(parent,text,label):
	Mes=wxMessageDialog(parent,text,label,wxICON_WARNING)
	Mes.ShowModal()
	Mes.Destroy()
class LookUp(wxDialog):
	def __init__(self,parent,Total):
 		wxDialog.__init__(self,parent,wxNewId(),'Searching in FreeDB database')
		self.SetSize((500,500))
		self.CenterOnParent()
		self.ControlsPanel=wxPanel(self,-1,pos=(0,450),size=(500,50))
		self.GenreStatic=wxStaticText(self.ControlsPanel,-1,'Genre:',wxPoint(10,15))
		self.GenreText=wxTextCtrl(self.ControlsPanel,wxNewId(),'',wxPoint(self.GenreStatic.GetPosition()[0]+self.GenreStatic.GetSize()[0]+10,10),wxSize(80,-1))
		self.YearStatic=wxStaticText(self.ControlsPanel,-1,'Year:',wxPoint(self.GenreText.GetPosition()[0]+self.GenreText.GetSize()[0]+10,15))
		self.YearText=wxTextCtrl(self.ControlsPanel,wxNewId(),'',wxPoint(self.YearStatic.GetPosition()[0]+self.YearStatic.GetSize()[0]+10,10),wxSize(80,-1))
 		self.Results=wxPanel(self,wxNewId(),wxPoint(0,0),wxSize(500,100))
		self.Tracklists=wxPanel(self,wxNewId(),wxPoint(0,100),wxSize(500,350))
		self.TestList=wxListCtrl(self.Results,wxNewId(),style=wxLC_REPORT|wxLC_NO_HEADER)
 		self.TestList.SetSize(self.Results.GetSize())
		self.TestList.InsertColumn(0,'Results:')
		self.TestList.SetColumnWidth(0,450)
		self.CancelButton=wxButton(self.ControlsPanel,wxNewId(),'Cancel',wxPoint(self.YearText.GetPosition()[0]+self.YearText.GetSize()[0]+10,10))
		self.WriteButton=wxButton(self.ControlsPanel,wxNewId(),'Write',wxPoint(self.CancelButton.GetPosition()[0]+self.CancelButton.GetSize()[0]+10,10))
		EVT_BUTTON(self.ControlsPanel,self.CancelButton.GetId(),self.Cancel)
		EVT_BUTTON(self.ControlsPanel,self.WriteButton.GetId(),self.Write)
		EVT_LIST_ITEM_ACTIVATED(self.TestList, self.TestList.GetId(), self.LoadTracks)
		self.ViewList=wxTextCtrl(self.Tracklists,-1,style=wxTE_MULTILINE)
		self.ViewList.SetSize(self.Tracklists.GetSize())
		self.ViewList.SetEditable(0)
		self.RetVal=''
		[self.AlbumId,self.Offsets,self.TotalTime]=PyCDDB.GetAlbumId(Total)
		self.Argument=[string.zfill(hex(self.AlbumId)[2:],8),str(len(self.Offsets))]+TranslateToStr(self.Offsets)+[str(self.TotalTime)]
		self.dbSession=PyCDDB.PyCDDB()
	def Query(self):
		try:
 			self.Items=self.dbSession.query(string.join(self.Argument))
			if len(self.Items)==0:
				self.RetVal=[]
				Message(self,text='No matches found',label='No matches')
				return 'bye'
			else:
				self.FoundResults()
		except IOError:
			Message(self,text='Unable to establish Internet connection',label='Error')
			self.RetVal=''
			return 'bye'
	def Write(self,event):
		self.RetVal=[self.Artist,self.Album,self.GenreText.GetValue(),self.YearText.GetValue(),self.Tracks]
		self.Close()
	def Cancel(self,event):
		self.RetVal=''
		self.Close()
	def LoadTracks(self,event):
 		if event==0:
 			self.SelectedInList=event
 		else:
 			self.SelectedInList=event.m_itemIndex
  		self.SelectedContains=self.dbSession.read(self.Items[self.SelectedInList])
		self.ViewList.Remove(0,len(self.ViewList.GetValue()))
		if '/' in self.SelectedContains['DTITLE']:
			(self.Artist,self.Album)=string.split(self.SelectedContains['DTITLE'],'/')
		else:
			try:
				(self.Artist,self.Album)=self.SelectedContains['DTITLE']
			except:
				try:
					self.Artist=self.SelectedContains['DTITLE']
					self.Album=''
				except:
					return
		self.Artist=string.strip(self.Artist)
		self.Album=string.strip(self.Album)
		self.Genre=self.SelectedContains['DGENRE']
		self.Year=self.SelectedContains['DYEAR']
		self.Tracks=self.SelectedContains['TTITLE']
		self.ViewList.WriteText('Summary of retrieved informations:\n\n')
		self.ViewList.WriteText('='*40+'\n')
		self.ViewList.WriteText('Artist: %s\n'%self.Artist[:38])
		self.ViewList.WriteText('Album: %s\n'%self.Album[:38])
		self.ViewList.WriteText('Genre: %s\n'%self.Genre[:38])
		self.ViewList.WriteText('Year: %s\n'%self.Year)
		self.ViewList.WriteText('='*40+'\n')
 		for self.Pos in range(len(self.Tracks)):
 			self.ViewList.WriteText('|'+string.zfill(str(self.Pos+1),2)+'| = '+self.Tracks[self.Pos]+'\n')
		self.YearText.Remove(0,len(self.YearText.GetValue()))
		self.YearText.WriteText(self.SelectedContains['DYEAR'])
		self.GenreText.Remove(0,len(self.GenreText.GetValue()))
		self.GenreText.WriteText(self.SelectedContains['DGENRE'])
	def FoundResults(self):
		for self.result in range(len(self.Items)):
 			self.TestList.InsertStringItem(self.result,self.Items[self.result]['title'])
 		self.LoadTracks(0)
