# Copyright (c) 2004 Marek Hnilica. All rights reserved.
# Module that provides one-by-one file tag editing.
# Distributed under GPL version 2, or (at your option) later

from wxPython.wx import *
import string,os
import AllTag
from utils import *
class mboxFileTagEdit(wxDialog):
	def __init__(self,parent,ID):
		wxDialog.__init__(self,parent,ID,'Edit')
		self.parent=parent
		ViewTags=wxStaticBoxSizer(wxStaticBox(self,-1,'Tags: '),wxVERTICAL)
		self.TitleArray=wxTextCtrl(self,-1,'',size=(300,-1))
		self.AlbumArray=wxTextCtrl(self,-1,'',size=(300,-1))
		self.ArtistArray=wxTextCtrl(self, -1,'', size=(300,-1))
		self.YearArray=wxTextCtrl(self, -1,'', size=(140, -1))
		self.GenreArray=wxTextCtrl(self, -1,'', size=(140, -1))
		self.CommArray=wxTextCtrl(self, -1,'', size=(300,80),style=wxTE_MULTILINE)
		
		self.TrackArray=wxComboBox(self,-1,'01',choices=[string.zfill(str(x),2) for x in range(1,30)])
		
		TagsSizer=wxFlexGridSizer(6,2,5,5)
		TagsSizer.AddMany([
		((0,10),0),
		((0,10),0),
		(wxStaticText(self, -1, "Title:"),0),
		(self.TitleArray),
		(wxStaticText(self, -1, "Album:"),0),
		(self.AlbumArray),
		(wxStaticText(self, -1, "Artist:"),0),
		(self.ArtistArray),
		(wxStaticText(self, -1, "Year:"),0),
		(self.YearArray),
		(wxStaticText(self, -1, "Genre:"),0),
		(self.GenreArray),
		(wxStaticText(self, -1, "Track number:"),0),
		(self.TrackArray,0),
		(wxStaticText(self, -1, "Comment:"),0),
		(self.CommArray),
		((0,10),0),
		((0,10),0),
		])
		ViewTags.Add(TagsSizer,0)
		
		
		
		ViewAPIC=wxStaticBoxSizer(wxStaticBox(self,-1,'Picture: '),wxVERTICAL)
		self.ImagePanel=wxPanel(self,-1,size=(200,200))
		self.AddImageToFile=wxButton(self,-1,'&Add image to audio file')
		self.SaveImageToFile=wxButton(self,-1,'Save &image to picture file')
		self.AddImageToFile.SetSize(self.SaveImageToFile.GetSize())
		ViewAPIC.AddMany([
		(self.ImagePanel),
		((0,10),0),
		(self.AddImageToFile,0,wxALIGN_CENTER),
		((0,3),0),
		(self.SaveImageToFile,0,wxALIGN_CENTER),
		])
		ViewAPIC.SetMinSize((ViewAPIC.GetMinSize()[0],ViewTags.GetMinSize()[1]))
		EVT_BUTTON(self,self.SaveImageToFile.GetId(),self.SaveToImg)
		EVT_BUTTON(self,self.AddImageToFile.GetId(),self.AddToFile)
		
		MainViewControls=wxFlexGridSizer(2,3,10,10)
		ViewControls=wxBoxSizer(wxHORIZONTAL)
		self.WriteButton=wxButton(self,wxNewId(),'&Save')
		self.PreviousButton=wxButton(self,wxNewId(),'<< &Previous')
		self.CancelButton=wxButton(self,wxNewId(),'&Close')
		self.NextButton=wxButton(self,wxNewId(),'&Next >>')
		self.AutoSave=wxCheckBox(self, wxNewId(),"C&licking on 'Previous', 'Close' and 'Next' appends to queue")
		self.AutoSave.SetValue(1)
		ViewControls.AddMany([
		(self.PreviousButton,0),
		((30,0),0),
		(self.WriteButton,0),
		((5,0),0),
		(self.CancelButton,0),
		((30,0),0),
		(self.NextButton,0),
		])
		MainViewControls.AddMany([
		((30,0),0),
		(ViewControls,0),
		((0,0),0),
		((0,0),0),
		(self.AutoSave,0),
		])
		EVT_BUTTON(self,self.CancelButton.GetId(),self.cancel)
		EVT_BUTTON(self,self.WriteButton.GetId(),self.write)
		EVT_BUTTON(self,self.NextButton.GetId(),self.next)
		EVT_BUTTON(self,self.PreviousButton.GetId(),self.prev)
		EVT_CLOSE(self,self.ExitDiag)
		ShowSizer=wxBoxSizer(wxHORIZONTAL)
		ShowSizer.AddMany([
		(ViewTags,0),
		(ViewAPIC,0),
		])
		
		MainSizer=wxBoxSizer(wxVERTICAL)
		MainSizer.AddMany([
		(ShowSizer,0),
		((0,20),0),
		(MainViewControls,0),
		((0,10),0),
		])
		self.SetSizer(MainSizer)
		self.SetAutoLayout(True)
		MainSizer.Fit(self)
		self.FillWithTags()
		self.CenterOnParent()
	def prev(self,junk):
		if self.AutoSave.GetValue() and self.WriteButton.IsEnabled():
			self.write('')
		self.FillWithTags(self.ActualNumber-1)
	def next(self,junk):
		if self.AutoSave.GetValue() and self.WriteButton.IsEnabled():
			self.write('')
		self.FillWithTags(self.ActualNumber+1)
	def FillWithTags(self,*number):
		self.Tracks=self.parent.parent.Tracks
		if len(number)==0:
			self.ActualNumber=self.Tracks.NumbersSelection[0]
		else:
			self.ActualNumber=number[0]
		if self.ActualNumber==0:
			self.PreviousButton.Enable(0)
		else:
			self.PreviousButton.Enable(1)
		if self.ActualNumber+1==len(self.Tracks.Tag):
			self.NextButton.Enable(0)
		else:
			self.NextButton.Enable(1)
		self.TagToShow=self.Tracks.Tag[self.ActualNumber]
		self.SetLabel('Editing %s'%self.TagToShow[0])
		self.TitleArray.SetValue(self.TagToShow[1])
		self.AlbumArray.SetValue(self.TagToShow[3])
		self.ArtistArray.SetValue(self.TagToShow[2])
		self.YearArray.SetValue(self.TagToShow[6])
		self.GenreArray.SetValue(self.TagToShow[4])
		self.CommArray.SetValue(self.TagToShow[9])
		self.TrackArray.SetValue(self.TagToShow[5])
		try:
			self.img.Destroy()
		except:
			pass
		if EvaluateTagType(self.TagToShow[0])=='Wma':
			self.WriteButton.Enable(0)
		else:
			self.WriteButton.Enable(1)
		if EvaluateTagType(self.TagToShow[0])=='MP3':
			self.AddImageToFile.Enable(1)
			self.SaveImageToFile.Enable(1)
			self.ShowImage()
		else:
			self.AddImageToFile.Enable(0)
			self.SaveImageToFile.Enable(0)
	def ExitDiag(self,evt):
		self.parent.parent.RenameTools.PendingCtrl.DoIt(self.parent.parent.RenameTools.DontWaitCheck.GetValue())
		self.Tracks.EvaluateTag(self.Tracks.CurrentDir,self.Tracks.TagType,Reload=0)
		evt.Skip()
	def cancel(self,junk):
		if self.AutoSave.GetValue() and self.WriteButton.IsEnabled():
			self.write('')
		self.Close()
		
	def write(self,junk):
		if junk=='DontDareToOverwrite':
			PictureAdded=1
		else:
			PictureAdded=0
			self.TagsToWrite={}
		self.TagsToWrite['TITLE']=self.TitleArray.GetValue()
		self.TagsToWrite['ARTIST']=self.ArtistArray.GetValue()
		self.TagsToWrite['ALBUM']=self.AlbumArray.GetValue()
		self.TagsToWrite['GENRE']=self.GenreArray.GetValue()
		self.TagsToWrite['TRACKNUMBER']=self.TrackArray.GetValue()
		self.TagsToWrite['YEAR']=self.YearArray.GetValue()
		self.TagsToWrite['COMMENT']=self.CommArray.GetValue()
		try:
			self.parent.parent.RenameTools.PendingCtrl.AddOperation(['tag',self.TagToShow[0],self.TagsToWrite])
		except IOError:
			GeneralError(self,text='Unable to write to %s'%self.TagToShow[0],label='Permission denied')
	def stripsub(self,text):
		Text=''
		for i in list(text):
			if ord(i)>20:
				Text+=i
		return Text
	def TreateImage(self):
 		self.Pos=1
		ImgType=''
		while ord(self.APIC[self.Pos]) != 0:
			ImgType+=self.APIC[self.Pos]
			self.Pos+=1
# One for moving + 1 for picture type
		self.Pos+=2
		while ord(self.APIC[self.Pos]) != 0:
			self.Pos+=1
# Just moving
		self.Pos+=1
 		image=self.APIC[self.Pos:]
 		filename=os.environ['HOME']+'/.mBox/last_image'
 		file=open(filename,'w')
 		file.write(image)
		return self.stripsub(ImgType)
	def ShowImage(self):
		self.APIC=self.Tracks.Tag[self.ActualNumber][10]
		if self.APIC=='':
			self.SaveImageToFile.Enable(0)
			return
		ImgType=string.lower(self.TreateImage())
		if (ImgType=='image/jpg') or (ImgType=='image/jpeg'):
			wxImageType=wxBITMAP_TYPE_JPEG
			self.Suffix='.jpg'
		elif ImgType=='image/png':
			wxImageType=wxBITMAP_TYPE_PNG
			self.Suffix='.png'
		elif ImgType=='image/gif':
			wxImageType=wxBITMAP_TYPE_GIF
			self.Suffix='.gif'
		elif ImgType=='image/bmp':
			wxImageType=wxBITMAP_TYPE_BMP
			self.Suffix='.bmp'
		else:
			GeneralError(self,text='This file contains unrecognized picture format (MIME:"%s")\nThis format is not supported by mBox and won\'t be shown.'%ImgType,label='Unsupported image format')
			self.SaveImageToFile.Enable(0)
			return
		image=wxImage(os.environ['HOME']+'/.mBox/last_image',wxImageType)
		PX=image.GetWidth()/200.0
		PY=image.GetHeight()/200.0
		PrevImage=image
		try:
			if cmp(PX,PY)==1:
				PrevImage=image.Scale(200,int(image.GetHeight()/PX))
			else:
				PrevImage=image.Scale(int(image.GetWidth()/PY),200)
			PrevImage=PrevImage.ConvertToBitmap()
			self.img=wxStaticBitmap(self.ImagePanel, -1, PrevImage)
			self.img.CenterOnParent()
# For broken image/s
		except:
			self.SaveImageToFile.Enable(0)
			
	def SaveToImg(self,junk):
		if hasattr(self,'Suffix'):
			wildcard="%s image |*%s"%(self.Suffix,self.Suffix)
			dlg = wxFileDialog(self, "Choose a file you want to save image to", os.getcwd(), "", wildcard,wxOPEN)
			if dlg.ShowModal() == wxID_OK:
				try:
					File=open(dlg.GetPath(),'w')
					File.write(self.APIC[self.Pos:])
					File.close()
				except IOError:
					GeneralError(self,text='Unable to write there!',label='Error')
			dlg.Destroy()
	def AddToFile(self,junk):
		wildcard=".jpg |*.jpg|" \
		".jpeg  |*.jpeg|" \
		".png |*.png|" \
		".gif |*.gif|" \
		".bmp |*.bmp"
		dlg = wxFileDialog(self, "Choose a image you want to add to audio file", os.getcwd(), "", wildcard,wxOPEN)
		if dlg.ShowModal()==wxID_OK:
			self.TagsToWrite={}
			datafile=open(dlg.GetPath(),'r')
			data=datafile.read()
			datafile.close()
			Meta='image/'+dlg.GetPath()[string.rfind(dlg.GetPath(),'.')+1:]
# We'll asume it's front cover + description will be maybe implemented later
			APICstring=chr(0)+Meta+chr(0)+chr(3)+chr(0)+data
			self.TagsToWrite['APIC']=APICstring
			self.write('DontDareToOverwrite')
			self.ShowImage()
		dlg.Destroy()
