# Copyright (c) 2004 Marek Hnilica. All rights reserved.
# This module contains 'Rename Directory' dialog and functionality.
# Distributed under GPL version 2, or (at your option) later
from wxPython.wx import *
import os,os.path,mp3,AllTag,ogg.vorbis,string,oggiface,sys,mboxUpper,mboxFileUtils,shutil,ComboBoxWithHistory
def PanicExit(parent,text='Error',label='Error'):
	ErrMsg=wxMessageDialog(parent,text,label,wxICON_WARNING)
	ErrMsg.ShowModal()
	ErrMsg.Destroy()
	parent.Close()
class RenameDialog(wxDialog):
	def __init__(self,parent,filename,choices=[],directory='',oklength=1):
		wxDialog.__init__(self,parent,-1,'Rename Directory')
		self.VeryFirstDir=directory
		self.FileList=os.listdir(self.VeryFirstDir)
		self.PrevDirList=[]
		for self.Element in self.FileList:
			self.PrevDirList.append(os.path.abspath(self.Element))
		self.filename=filename
		self.mbox=parent
		
		
		MaskSizer=wxStaticBoxSizer(wxStaticBox(self,-1,'Controls:'))
		self.RenameMask=ComboBoxWithHistory.wxComboBoxWithHistory(self,wxNewId(),choices=choices)
		self.RenameButton=wxButton(self,wxNewId(),'&Rename')
		self.CancelButton=wxButton(self,wxNewId(),'&Cancel')
		MaskSizer.AddMany([
		(self.RenameMask,1),
		((20,0),0),
		(self.RenameButton,0),
		((5,0),0),
		(self.CancelButton,0),
		])
		
		TextSizer=wxBoxSizer(wxHORIZONTAL)
		TextPossSizer=wxStaticBoxSizer(wxStaticBox(self,-1,'File mask possibilities:'))
		TextPossSizer.AddMany([
		(wxStaticText(self,-1,'%a = Artist\n%y = Year\n%c = Comment'),0),
		((5,0),0),
		(wxStaticText(self,-1,'%l = Album\n%g = Genre\n%b = Bitrate'),0),
		])
		TextSizer.Add(TextPossSizer,0)
		self.ReplaceSpaces=wxCheckBox(self,wxNewId(),"Replace spaces with underscores",style=wxNO_BORDER)
		self.ModifyStatus=wxCheckBox(self,wxNewId(),"Enable case adjustments",style=wxNO_BORDER)
		EVT_CHECKBOX(self,self.ModifyStatus.GetId(),self.ModifyEnable)
 		self.Modify=wxRadioBox(self,wxNewId(),"Case:",wxPoint(-1,-1),wxSize(-1,-1),['lower','UPPER','Capitalize first word','Capitalize First Letter'],2)
		self.Modify.Enable(0)
		ModifSizer=wxStaticBoxSizer(wxStaticBox(self,-1,'Dir name modifications:'),wxVERTICAL)
		ModifSizer.AddMany([
		(self.ReplaceSpaces,0),
		(self.ModifyStatus,0),
		(self.Modify,0),
		])
		TextPossSizer.SetMinSize(ModifSizer.GetMinSize())
		TextSizer.AddMany([
		((5,5),0),
		(ModifSizer,0)
		])
		MainSizer=wxFlexGridSizer(5,1,10,5)
		PrevSizer=wxStaticBoxSizer(wxStaticBox(self,-1,'Preview:'))
		self.TempText=wxStaticText(self,-1,'')
		PrevSizer.Add(self.TempText,0)
		MainSizer.AddMany([
		(PrevSizer,0),
		(MaskSizer,0),
		(TextSizer,0),
		((0,10),0),
		])
		
		self.TextInMask=''
		EVT_TEXT(self,self.RenameMask.GetId(), self.RenameMaskEntered)
		EVT_BUTTON(self,self.RenameButton.GetId(),self.DoRename)
		EVT_BUTTON(self,self.CancelButton.GetId(),self.Cancel)
		self.SetSizer(MainSizer)
		self.SetAutoLayout(True)
		MainSizer.Fit(self)
		PrevSizer.SetMinSize((self.GetSize()[0],-1))
		MaskSizer.SetMinSize((self.GetSize()[0],-1))
		self.CenterOnParent()
		self.Show()
		if not oklength:
			self.WrongSelection=wxMessageDialog(self,'Wrong files selected, you have to select only one file in tracklist.\nUsing first file for tag info','Error',wxICON_INFORMATION)
			self.WrongSelection.ShowModal()
			self.WrongSelection.Destroy()
	def ModifyEnable(self,event):
		self.Modify.Enable(event.Checked())
	def Cancel(self,event):
		self.Close()
		self.RetVal=''
		return
	def FutName(self,text,var):
		self.FutureName=string.replace(self.FutureName,text,var)
	def StripList(self,List):
		while '' in List:
			List.remove('')
		return List
	def DoRename(self,junk):
		self.RenameMask.AddToHistory(self.RenameMask.GetValue())
		self.MakeVariables()
		self.FutureName=self.TextInMask
		self.FutName('<ARTIST>',self.NameArtist)
		self.FutName('<ALBUM>',self.NameAlbum)
		self.FutName('<YEAR>',self.NameYear)
		self.FutName('<GENRE>',self.NameGenre)
		self.FutName('<COMMENT>',self.NameComment)
		self.FutName('<BITRATE>',`self.NameBitrate`)
		if self.ReplaceSpaces.GetValue():
			self.FutureName=string.replace(self.FutureName,' ','_')
		self.TempDirName=self.StripList(string.split(self.VeryFirstDir,'/'))
		del self.TempDirName[len(self.TempDirName)-1]
		try:
			if self.FutureName[0]=='/':
				self.FutureDirSplit=self.StripList(string.split(self.FutureName,'/'))
				self.FutureDir=self.FutureName
			else:
				self.FutureDirSplit=self.TempDirName+self.StripList(string.split(self.FutureName,'/'))
				self.FutureDir='/'+string.join(self.FutureDirSplit,'/')
		except IndexError:
			self.FutureDirSplit=self.TempDirName+self.StripList(string.split(self.FutureName,'/'))
			self.FutureDir='/'+string.join(self.FutureDirSplit,'/')
		self.AlreadyAdded=''
		self.Broken=0
		for self.TempDir in self.FutureDirSplit:
			self.AlreadyAdded+='/'+self.TempDir
			if os.path.exists(self.AlreadyAdded):
				if not os.path.isdir(self.AlreadyAdded):
					self.Broken=1
 					break
				continue
			else:
				try:
					os.mkdir(self.AlreadyAdded)
				except OSError:
					if self.AlreadyAdded[-1:]==' ':
						print '*** Failed to create directory "%s", \n\ttrying to strip trailing whitespaces and create dir again...'%self.AlreadyAdded,
						# Could have failed because some filesystems doesn't allow whitespace character as last character in dirname
						self.AlreadyAdded=string.rstrip(self.AlreadyAdded)
						try:
							os.mkdir(self.AlreadyAdded)
							print 'succes'
						except OSError:
							print 'failed'
							self.ErrMsg=wxMessageDialog(self,'Unable to create directory "%s"\n\nPlease check whether you have appropriate permissions.'%self.AlreadyAdded,'Error while renaming',wxICON_INFORMATION)
							self.ErrMsg.ShowModal()
							self.ErrMsg.Destroy()
							self.Close()
							self.RetVal='bye'
							return
		if self.Broken:
 			self.FutureName=self.VeryFirstDir
			self.WarnMessage=wxMessageDialog(self,'Unable to create directory %s\nPath already exists and is not a directory.'%self.ParDir,'Error message',wxICON_WARNING)
			self.WarnMessage.ShowModal()
			self.WarnMessage.Destroy()
			self.Close()
			self.RetVal='bye'
			return
		for self.file in self.PrevDirList:
			self.Errors=0
 			try:
				if not hasattr(self,'MakeCopy'):
					os.rename(self.file,self.AlreadyAdded+'/'+os.path.basename(self.file))
			except OSError,e:
				if string.find(str(e),'Errno 18')!=-1:
					if not hasattr(self,'MakeCopy'):
						ErrMsg=wxMessageDialog(self,'Unable to rename directory:\nDestination is in other partition.\nDo you want to move that files instead?','Unable to rename',wxICON_INFORMATION|wxOK|wxCANCEL)
						if ErrMsg.ShowModal()==wxID_OK:
							self.MakeCopy=1
						else:
							self.MakeCopy=0
						ErrMsg.Destroy()
						break
				else:
					ErrMsg=wxMessageDialog(self,'Unable to process directory "%s"\n\nPlease check whether you have appropriate permissions.'%self.AlreadyAdded,'Error while renaming',wxICON_INFORMATION)
					ErrMsg.ShowModal()
					ErrMsg.Destroy()
					try:
						os.rmdir(self.FutureName)
					except:
						pass
					self.Close()
					self.RetVal='bye'
					return
		if hasattr(self,'MakeCopy'):
			if self.MakeCopy:
				try:
					status=0
					mboxFileUtils.CopyTree(os.path.split(self.file)[0],self.FutureName)
					status=1
					shutil.rmtree(os.path.split(self.file)[0])
				except (shutil.Error,OSError),e:
					if status==0:
						ErrMsg=wxMessageDialog(self,'Moving failed - cannot copy source directory-tree','Error!',wxICON_INFORMATION|wxOK)
					elif status==1:
						ErrMsg=wxMessageDialog(self,'Moving failed - cannot delete source directory-tree','Error!',wxICON_INFORMATION|wxOK)
					ErrMsg.ShowModal()
					ErrMsg.Destroy()
			self.RetVal=''
			self.Close()
			return
		try:
  			os.rmdir(self.VeryFirstDir)
		except OSError:
			pass
		self.Close()
		self.FutureName=self.AlreadyAdded
		self.RetVal=''
	def RenameMaskEntered(self,event):
		if not hasattr(self,'TagX'):
			self.TagX,self.TagY=self.TempText.GetPosition()
		self.TextInMask=self.ReplacePercents(self.RenameMask.GetValue())
		try:
			self.MaskText.Destroy()
		except:
			pass
		self.MaskText=wxStaticText(self,-1,self.TextInMask,pos=(self.TagX,self.TagY))
	def ModifyCase(self,name):
		if self.ModifyStatus.GetValue():
			if self.Modify.GetStringSelection()=='lower':
				name=string.lower(name)
			elif self.Modify.GetStringSelection()=='UPPER':
				name=string.upper(name)
			elif self.Modify.GetStringSelection()=='Capitalize first word':
				name=string.capitalize(name)
			elif self.Modify.GetStringSelection()=='Capitalize First Letter':
				name=mboxUpper.BetterCapword(name)
		return name
	def MakeVariables(self):
		self.infofile=AllTag.Tag(self.filename)
		self.NameArtist=self.ModifyCase(self.infofile.ARTIST)
		self.NameAlbum=self.ModifyCase(self.infofile.ALBUM)
		self.NameYear=self.ModifyCase(self.infofile.YEAR)
		self.NameGenre=self.ModifyCase(self.infofile.GENRE)
		self.NameComment=self.ModifyCase(self.infofile.COMMENT)
		self.NameBitrate=self.infofile.BITRATE
	def ReplacePercents(self,text):
		text=string.replace(text,'%a','<ARTIST>')
		text=string.replace(text,'%l','<ALBUM>')
		text=string.replace(text,'%y','<YEAR>')
		text=string.replace(text,'%g','<GENRE>')
		text=string.replace(text,'%c','<COMMENT>')
		text=string.replace(text,'%b','<BITRATE>')
		return text
