# Copyright (c) 2004 Marek Hnilica. All rights reserved.
# Module that provides 'Edit time' dialog
# Distributed under GPL version 2, or (at your option) later

from wxPython.wx import *
from wxPython.lib.intctrl import *
class TimeEdit(wxDialog):
	def __init__(self,parent,seconds):
		wxDialog.__init__(self,parent,-1,'Edit time')
		self.Closed=0
		self.second_control=wxIntCtrl(self)
		self.second_control.SetLimited(1)
		self.second_control.SetBounds(min=0,max=59)
		self.second_control.SetValue(seconds%60)
		self.minutes_control=wxIntCtrl(self)
		self.minutes_control.SetValue(seconds/60)
		OkButton=wxButton(self,wxNewId(),'Set!')
		CancelButton=wxButton(self,wxNewId(),'Cancel')

		EVT_BUTTON(self,OkButton.GetId(),self.Okay)
		EVT_BUTTON(self,CancelButton.GetId(),self.Cancel)
		sizer=wxFlexGridSizer(2,2,10,10)
		sizer.AddMany([
		(wxStaticText(self,-1,'Minutes:'),0,wxALIGN_RIGHT|wxNORTH,10),
		(self.minutes_control,0,wxALIGN_LEFT|wxNORTH,10),
		(wxStaticText(self,-1,'Seconds:'),0,wxALIGN_RIGHT),
		(self.second_control,0,wxALIGN_LEFT),
		])
		
		buttonsizer=wxBoxSizer(wxHORIZONTAL)
		buttonsizer.AddMany([
		(OkButton,0),
		(CancelButton,0)
		])
		
		BoxSizer=wxStaticBoxSizer(wxStaticBox(self,-1,'Set values:'),0)
		BoxSizer.Add(sizer)
		
		MainSizer=wxBoxSizer(wxVERTICAL)
		MainSizer.AddMany([
		(BoxSizer,0,wxALL,20),
		(buttonsizer,0,wxALIGN_CENTER|wxSOUTH,10)
		])
		
		
		MainSizer.Fit(self)
		self.SetAutoLayout(True)
		self.SetSizer(MainSizer)
		self.CenterOnParent()
	def Cancel(self,junk):
		self.Close()
	def Okay(self,junk):
		self.NewTime=self.second_control.GetValue()+self.minutes_control.GetValue()*60
		self.Closed=1
		self.Close()