from wxPython.wx import *
from wxPython.lib.mixins.listctrl import wxListCtrlAutoWidthMixin
import os
class TagTestDiag(wxDialog):
	def __init__(self,parent,Tags):
		wxDialog.__init__(self,parent,-1,'Mask test',size=(550,350),style=wxRESIZE_BORDER)
		self.CenterOnParent()
		self.List=TagTestList(self,Tags)
class TagTestList(wxListCtrl,wxListCtrlAutoWidthMixin):
	def __init__(self,parent,Tags):
		wxListCtrl.__init__(self,parent,-1,style=wxLC_REPORT|wxLC_VRULES|wxLC_HRULES)
		wxListCtrlAutoWidthMixin.__init__(self)
		Columns=Tags[0][1].keys()
		self.InsertColumn(0,'Filename')
		self.ColumnPos={}
		for text in ['TITLE','ARTIST','ALBUM','TRACKNUMBER','YEAR','GENRE','COMMENT']:
			if text in Columns:
				self.CreateColumn(text)
		for tag in Tags:
			self.InsertStringItem(self.GetItemCount(),os.path.basename(tag[0]))
			for key in tag[1].keys():
				try:
					self.SetStringItem(self.GetItemCount()-1,self.ColumnPos[key],tag[1][key])
				except KeyError:
					pass
		for i in range(self.GetItemCount()):
			self.SetColumnWidth(i,wxLIST_AUTOSIZE)
			if self.GetColumnWidth(i)<50:
				self.SetColumnWidth(i,50)
			elif self.GetColumnWidth(i)>250:
				self.SetColumnWidth(i,250)
	def CreateColumn(self,text):
		self.ColumnPos[text]=self.GetColumnCount()
		if text!='TRACKNUMBER':
			self.InsertColumn(self.GetColumnCount(),text.capitalize())
		else:
			self.InsertColumn(self.GetColumnCount(),'Track #')
