from wxPython.wx import *
import os,types,threading,string,stat
import AllTag
from utils import *
class PendingList(wxTextCtrl):
	def __init__(self,parent,tracklist):
		self.Tracks=tracklist
		self.MainWindow=parent.GetParent().GetParent()
		wxTextCtrl.__init__(self,parent,wxNewId(),style=wxSIMPLE_BORDER|wxTE_MULTILINE|wxTE_DONTWRAP|wxTE_READONLY)
		self.AlreadyDoneDirs=[]
		self.AlreadyChmodedDirs=[]
		self.OperationList=[]
	def ShowOperation(self):
		self.Restart(delete=0)
		for OpPos in range(len(self.OperationList)):
			Op0=self.OperationList[OpPos][0]
			Op1=self.OperationList[OpPos][1]
		# for chmod-dir which has only one argument
			try:
				Op2=self.OperationList[OpPos][2]
			except IndexError:
				pass
			if Op0=='rename':
				InsPo=self.GetInsertionPoint()
				self.WriteText('Rename file %s to %s\n'%(os.path.basename(Op1),os.path.basename(Op2)))
				self.SetStyle(InsPo,len(self.GetValue()), wxTextAttr((39,42,185),'WHITE'))
			elif Op0=='chmod':
				InsPo=self.GetInsertionPoint()
				self.WriteText('Change permission of %s\n'%os.path.basename(Op1))
				self.SetStyle(InsPo,len(self.GetValue()), wxTextAttr((255,27,27),'WHITE'))
			elif Op0=='tag':
				WillAddPicture=0
				Sentence='Set tags in %s to these values: '%os.path.basename(Op1)
				for i in Op2.keys():
					if not i=='APIC':
						Sentence+=i.capitalize()+': \''+Op2[i]+'\' '
					else:
						WillAddPicture=1
				if WillAddPicture:
					Sentence+=' and add picture.\n'
				else:
					Sentence+='\n'
				self.WriteText(Sentence)
			elif Op0=='chmod-dir':
				InsPo=self.GetInsertionPoint()
				self.WriteText('Change permission of directory %s\n'%Op1)
				self.SetStyle(InsPo,len(self.GetValue()), wxTextAttr((255,27,27),'WHITE'))
	def AddOperation(self,Operation):
		if Operation[0]=='tag':
			TestName=Operation[1]
			reversed=self.OperationList[:]
			reversed.reverse()
			WillAddPicture=0
			changed=0
			for op in reversed:
				if op[0]=='rename' and op[2]==TestName:
					TestName=op[1]
					changed=1
			if not os.access(TestName,os.W_OK+os.R_OK):
				if os.stat(TestName)[stat.ST_UID]!=os.getuid():
					raise IOError
				else:
					if changed:
						toadd=op[1]
					else:
						toadd=Operation[1]
					self.AddOperation(['chmod',toadd,420])
			# Modifies tag in main tracklist
			for TagPos in range(len(self.Tracks.Tag)):
				if self.Tracks.Tag[TagPos][0]==Operation[1]:
					NewList=list(self.Tracks.Tag[TagPos])
					TagDict=Operation[2]
					if TagDict.has_key('ARTIST'):
						NewList[2]=TagDict['ARTIST']
					if TagDict.has_key('ALBUM'):
						NewList[3]=TagDict['ALBUM']
					if TagDict.has_key('GENRE'):
						NewList[4]=TagDict['GENRE']
					if TagDict.has_key('YEAR'):
						NewList[6]=TagDict['YEAR']
					if TagDict.has_key('COMMENT'):
						NewList[9]=TagDict['COMMENT']
					if TagDict.has_key('TITLE'):
						NewList[1]=TagDict['TITLE']
					if TagDict.has_key('TRACKNUMBER'):
						NewList[5]=TagDict['TRACKNUMBER']
					if TagDict.has_key('APIC'):
						NewList[10]=TagDict['APIC']
					self.Tracks.Tag[TagPos]=NewList
		elif Operation[0]=='rename':
			DirName=os.path.dirname(Operation[2])
			if not os.access(DirName,os.W_OK):
				if os.stat(DirName)[stat.ST_UID]!=os.getuid():
					raise IOError
				else:
					self.AddOperation(['chmod-dir',os.path.abspath(DirName)])
			# modifies tag in main tracklist
			for TagPos in range(len(self.Tracks.Tag)):
				if self.Tracks.Tag[TagPos][0]==Operation[1]:
					NewList=list(self.Tracks.Tag[TagPos])
					NewList[0]=Operation[2]
					self.Tracks.Tag[TagPos]=NewList
		elif Operation[0]=='chmod-dir':
			if not Operation[1] in self.AlreadyChmodedDirs:
				self.AlreadyChmodedDirs.append(Operation[1])
				self.OperationList.append(Operation)
		if not Operation[0]=='chmod-dir':
			self.OperationList.append(Operation)
		self.ToolbarButtonsState=0
	def DoIt(self,ReallyDoIt=1):
		if not ReallyDoIt:
			self.ShowOperation()
			return
		ProgDiag=wxProgressDialog('Please wait','\t\t\t\t\t\t\t\t\t\t',len(self.OperationList),None,wxPD_APP_MODAL|wxPD_AUTO_HIDE)
		Pos=0
		Errors=[]
		for Operation in self.OperationList:
			if Operation[0]=='tag':
				ProgDiag.Update(Pos,'writing to %s'%os.path.basename(Operation[1]))
				try:
					AllTag.WriteTag(Operation[1],Operation[2])
				except:
					Errors.append('Failed to write tags to file %s'%Operation[1])
			if Operation[0]=='chmod':
				ProgDiag.Update(Pos,'changing permission of %s'%os.path.basename(Operation[1]))
				try:
					os.chmod(Operation[1],Operation[2])
				except:
					Errors.append('Failed to rename file %s'%Operation[1])
			if Operation[0]=='chmod-dir':
				if not Operation[0] in self.AlreadyDoneDirs:
					ProgDiag.Update(Pos,'changing permission of %s'%os.path.basename(Operation[1]))
					os.system('chmod 755 %s'%Operation[1])
					self.AlreadyDoneDirs.append(Operation[0])
			if Operation[0]=='rename':
				ProgDiag.Update(Pos,'renaming %s'%os.path.basename(Operation[1]))
				NewFilename=Operation[2]
				try:
					os.rename(Operation[1],Operation[2])
				except OSError:
					NameList=list(os.path.basename(Operation[2]))
					NewName=[]
					for letter in NameList:
						if not letter in string.punctuation or letter=='-' or letter=='.' or letter=='/':
							NewName.append(letter)
					try:
						os.rename(Operation[1],os.path.join(os.path.dirname(Operation[2]),string.join(NewName,'')))
						Errors.append('It seems that filesystem is not able to cope with some characters in\n\tfilename %s \n\tThese characters has been removed so final filename is bit different.'%Operation[2])
					except:
						Errors.append('Failed to rename file %s to %s'%(Operation[1],Operation[2]))
						
					# for multiple-times renamed files
					for i in range(len(self.OperationList)):
						if self.OperationList[i][1]==Operation[2]:
							self.OperationList[i]=[self.OperationList[i][0],string.join(NewName,''),self.OperationList[i][2]]
			Pos+=1
		if Errors:
			GeneralError(None,label='Errors:',text=string.join(Errors,'\n'))
		ProgDiag.Hide()
		ProgDiag.Destroy()
		self.Restart()
	def Restart(self,delete=1):
		if delete:
			self.OperationList=[]
			self.AlreadyChmodedDirs=[]
		self.Clear()
		self.AlreadyDoneDirs=[]
		self.ToolbarButtonsState=1
	def ShowUpdate(self,WillExit=0):
		if len(self.OperationList)>0:
			diag=wxMessageDialog(self,'Do you want to save changes?','Unsaved changes',wxYES|wxNO|wxCANCEL|wxICON_INFORMATION)
			RetVal=diag.ShowModal()
			if RetVal==wxID_YES:
				self.DoIt()
			elif RetVal==wxID_NO:
				self.Restart()
				if not WillExit:
					self.MainWindow.Tracks.EvaluateTag(self.MainWindow.Tracks.CurrentDir,self.MainWindow.Tracks.TagType)
			elif RetVal==wxID_CANCEL:
				return 'cancel'
